=== docs/requirements.txt ===
mkdocs-material
mkdocs-exclude
mkdocs-glightbox
mkdocs-video
pygments
