=== cmake/cincludeme/CMakeLists.txt ===
add_executable(cincludeme cincludeme.cpp)
