=== debian/changelog ===
contour (0.6.1.7494-1) unstable; urgency=medium

  * Initial release

 -- April Lu <apr3vau@outlook.com>  Tue, 01 Jul 2025 18:38:02 +0800
