=== debian/control ===
Source: contour
Section: devel
Priority: optional
Maintainer: April Lu <apr3vau@outlook.com>
Build-Depends: debhelper-compat (= 13), cmake, extra-cmake-modules, g++-13,
 libfreetype-dev, libharfbuzz-dev, libfontconfig-dev, qt6-base-dev,
 qt6-declarative-dev, qt6-5compat-dev, libyaml-cpp-dev, catch2, libmsgsl-dev,
 librange-v3-dev, libutempter-dev, extra-cmake-modules, libssh2-1-dev,
 libx11-xcb-dev, ncurses-bin, libgl1-mesa-dev, libglvnd-dev, libunicode-dev,
 libboxed-cpp-dev, libreflection-cpp-dev,
 qml6-module-qt-labs-platform, qml6-module-qtqml-workerscript,
 qml6-module-qtquick-controls, qml6-module-qtquick-layouts,
 qml6-module-qtmultimedia, qml6-module-qtquick-templates,
 qml6-module-qtquick-window, qml6-module-qt5compat-graphicaleffects,
 qt6-base-dev-tools, qt6-multimedia-dev, qt6-qpa-plugins
Standards-Version: 4.6.0
Homepage: https://github.com/contour-terminal/contour
Rules-Requires-Root: no

Package: contour
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Modern C++ Terminal Emulator
 contour is a modern and actually fast, modal, virtual terminal emulator,
 for everyday use. It is aiming for power users with a modern feature mindset.
