=== debian/watch ===
version=4
# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%contour-$1.tar.gz%" \
   https://github.com/contour-terminal/contour/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
