=== debian/changelog ===
contour (2.0+git2012021501-0ubuntu2) precise; urgency=low

  * contour depends on contour-data

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 15 Mar 2012 11:29:47 +0000

contour (2.0+git2012021501-0ubuntu1) precise; urgency=low

  * Initial release

 -- Rodrigo Belem <rbelem@ubuntu.com>  Tue, 14 Feb 2012 15:09:17 -0400
